searchNodes=[{"ref":"OneDHCPD.html","title":"OneDHCPD","type":"module","doc":"The One Address DHCP Server! This is a simple DHCP server for supplying IP addresses on point-to-point Ethernet links. To use it, specify a static IPv4 address on the Ethernet interface and then start the server up. OneDHCPD can supply an IPv4 address for you by calling OneDHCPD.default_ip_address/1 that should minimize IP conflicts with the user&#39;s network and other OneDHCPD servers. This is the recommended approach. Here&#39;s an example of using OneDHCPD with Nerves.Network: iex&gt; Nerves.Network.setup(&quot;usb0&quot;, ipv4_address_method: :static, ipv4_address: OneDHCPD.default_ip_address(&quot;usb0&quot;), ipv4_subnet_mask: OneDHCPD.default_subnet_mask()) :ok iex&gt; OneDHCPD.start_server(&quot;usb0&quot;) {:ok, #PID&lt;0, 220.0}"},{"ref":"OneDHCPD.html#default_ip_address/1","title":"OneDHCPD.default_ip_address/1","type":"function","doc":"Return the default server IP address that would be used for the specified interface."},{"ref":"OneDHCPD.html#default_subnet_mask/0","title":"OneDHCPD.default_subnet_mask/0","type":"function","doc":"Return the subnet mask that goes along with default_ip_address/1."},{"ref":"OneDHCPD.html#start_server/2","title":"OneDHCPD.start_server/2","type":"function","doc":"Start a DHCP server running on the specified interface. If one is already running, {:error, {:already_started, pid}} is returned. The server takes the following options: :port - the UDP port number to use (specify if debugging) :subnet - a /30 IP subnet to use"},{"ref":"OneDHCPD.html#stop_server/1","title":"OneDHCPD.stop_server/1","type":"function","doc":"Stop a DHCP server."},{"ref":"OneDHCPD.ARP.html","title":"OneDHCPD.ARP","type":"module","doc":"This module contains utilities to view or update the ARP cache. OneDHCPD uses this to update the ARP cache when the IP address is given out. If networking isn&#39;t working, OneDHCPD.ARP.entries/0 is useful for debugging."},{"ref":"OneDHCPD.ARP.html#entries/0","title":"OneDHCPD.ARP.entries/0","type":"function","doc":"Query the ARP cache and return everything in it. Currently this function is only used for debug."},{"ref":"OneDHCPD.ARP.html#replace/3","title":"OneDHCPD.ARP.replace/3","type":"function","doc":"Replace an entry in the ARP cache."},{"ref":"OneDHCPD.IPCalculator.html","title":"OneDHCPD.IPCalculator","type":"module","doc":"This module handles IP address calculations. The most involved of the calculations is the determination of a good IP subnet to use. OneDHCPD subnet tries for the following: Subnets should be the same across reboots (convenience and no surprise conflicts) Support running on more than one interface (unique subnets on device) Support hosts than have more than one device (unique subnets between devices) Don&#39;t conflict with the IPs used on the host for Internet The algorithm here is to hash the hostname (uniqueness between devices assuming the hostname is unique) and the network interface (uniqueness on device). Then use those bits to pick a subnet in the 172.31.0.0/16 private address range. That private range was picked arbitrarily since 10.0.0.0/8 and 192.168.0.0/16 ranges are commonly used. 172.18.0.0/16 is used by Docker."},{"ref":"OneDHCPD.IPCalculator.html#default_subnet/1","title":"OneDHCPD.IPCalculator.default_subnet/1","type":"function","doc":"Calculate the default subnet for the specified Ethernet interface."},{"ref":"OneDHCPD.IPCalculator.html#default_subnet/2","title":"OneDHCPD.IPCalculator.default_subnet/2","type":"function","doc":"Calculate the default subnet for the specified Ethernet interface and specify the hostname manually."},{"ref":"OneDHCPD.IPCalculator.html#mask/0","title":"OneDHCPD.IPCalculator.mask/0","type":"function","doc":"Return the subnet mask. Currently this is hardcoded to a /30 network."},{"ref":"OneDHCPD.IPCalculator.html#our_ip_address/1","title":"OneDHCPD.IPCalculator.our_ip_address/1","type":"function","doc":"Return our IP address. This is the one that should be set as a static address on the interface if using the defaults."},{"ref":"OneDHCPD.IPCalculator.html#prefix_length/0","title":"OneDHCPD.IPCalculator.prefix_length/0","type":"function","doc":"Return the prefix length that OneDHCPD uses."},{"ref":"OneDHCPD.IPCalculator.html#their_ip_address/1","title":"OneDHCPD.IPCalculator.their_ip_address/1","type":"function","doc":"Return the IP address that&#39;s given out to the client."},{"ref":"OneDHCPD.Message.html","title":"OneDHCPD.Message","type":"module","doc":"DHCP Message See RFC2131 and associated docs for details. This implementation is only intended to be complete enough to support the OneDHCPD use case."},{"ref":"OneDHCPD.Message.html#decode/1","title":"OneDHCPD.Message.decode/1","type":"function","doc":"Decode the contents of a UDP packet"},{"ref":"OneDHCPD.Message.html#encode/1","title":"OneDHCPD.Message.encode/1","type":"function","doc":"Encode a message so that it can be put in a UDP packet"},{"ref":"OneDHCPD.Message.html#response/1","title":"OneDHCPD.Message.response/1","type":"function","doc":"Create a response to a request with some fields filled in. See RFC 2131 Table 3 for requirements. The caller is responsible for most of the fields."},{"ref":"OneDHCPD.Message.html#t:t/0","title":"OneDHCPD.Message.t/0","type":"type","doc":""},{"ref":"readme.html","title":"one_dhcpd","type":"extras","doc":"one_dhcpd This is a simple DHCP server that&#39;s capable of giving out just one IP address. The use case is to support connecting Nerves devices directly to laptops. Yes, there are many ways of solving this problem. It took a long time to give up on the available alternatives and write this, and we may end up abandoning this project. Until then, there&#39;s one_dhcpd. If you&#39;re looking for a DHCP server, check out dhcp_server. Note that since this project was developed independent of that one, we were able to change the license to Apache-2.0 to be in line with other Nerves projects."},{"ref":"readme.html#usage","title":"one_dhcpd - Usage","type":"extras","doc":"Before using this directly, check whether you can use it via nerves_init_gadget or another initialization application. If you&#39;d like to manually use this, see the Hex docs for details."}]